The BOOST_PP_REPEAT_FROM_TO_D_z macro represents a fast horizontal repetition construct. It reenters both BOOST_PP_REPEAT and BOOST_PP_WHILE with maximum efficiency.

#### Usage

BOOST_PP_REPEAT_FROM_TO_D_z(d, first, last, macro, data)

#### Arguments

z
  The next available BOOST_PP_REPEAT dimension.
d
  The next available BOOST_PP_WHILE iteration.
first
  The lower bound of the repetition. Valid values range from 0 to BOOST_PP_LIMIT_MAG.
last
  The upper bound of the repetition. Valid values range from 0 to BOOST_PP_LIMIT_MAG.
macro
  A ternary operation of the form macro(z, n, data). This macro is expanded by BOOST_PP_REPEAT with the next available repetition depth, the current repetition number, and the auxiliary data argument.
data
  Auxiliary data passed to macro.

#### Remarks

This macro expands to the sequence:
macro(z, first, data) macro(z, first + 1, data) ... macro(z, last - 1, data)
The number of repetitions (i.e. last - first) must not exceed BOOST_PP_LIMIT_REPEAT.
The z value that is passed to macro represents the next available repetition dimension. Other macros that have _Z suffix variants internally use BOOST_PP_REPEAT--for example, BOOST_PP_ENUM_PARAMS and BOOST_PP_ENUM_PARAMS_Z. Using these _Z versions is not strictly necessary, but passing the z value (that is passed to macro) to these macros allows them to reenter BOOST_PP_REPEAT with maximum efficiency.

#### See Also

- BOOST_PP_LIMIT_MAG
- BOOST_PP_LIMIT_REPEAT
- BOOST_PP_REPEAT_FROM_TO
- BOOST_PP_REPEAT_FROM_TO_D

#### Requirements

Header: <boost/preprocessor/repetition/repeat_from_to.hpp>

© Copyright Housemarque Oy 2002 © Copyright Paul Mensonides 2002

Distributed under the Boost Software License, Version 1.0. (See accompanying file LICENSE_1_0.txt or copy at www.boost.org/LICENSE_1_0.txt)